#!/usr/bin/python
# -*- coding:utf-8 -*-

from fortunecollector import *

def getInformation():
    return ( 'excite', 'constellation', 'Japanese' )

def newInstance( key ):
    return Excite_Constellation( key )

class Excite_Constellation ( FortuneCollector ):
    def __init__( self, key = None ):
        FortuneCollector.__init__( self, "Excite", key )
        if FortuneCollector.CONSTELLATIONS.count( key ) == 0:
            raise Exception( "cannot accept key " + key )
        import time
        lt = time.localtime()
        if lt[ 3 ] < 8: lt = time.localtime( time.time() - 24 * 3600 )
        yr = ( "%d" % lt[ 0 ] )[ -2: ]
        mn = ( "0%d" % ( lt[ 1 ] ) )[ -2: ]
        dt = ( "0%d" % ( lt[ 2 ] ) )[ -2: ]
        shortkey = key[ 0: 2 ]
        if key == 'capricorn': shortkey = 'cp'
        url = "http://woman.excite.co.jp/fortune/horoscopes/horoscopes_result/?date=%s%s%s&sign=%s" % ( yr, mn, dt, shortkey )
        self.setURL( url )
        self.setScoreUnits( 5 )
        pass

    def parseHTML( self, filename ):
        import re, string
        fh = open( filename )
        count_current = 0
        item = None
        flag_start = False
        line = fh.readline()
        message = None
        sum_score = 0
        num_score = 0
        ## skip
        while len( line ) > 0:
            if line.find( '前の日の運勢' ) > 0: break
            line = fh.readline()
            pass

        ## read
        while len( line ) > 0:
            if line.find( '他の日の運勢' ) > 0:
                break
            elif line.find( '恋愛運' ) > 0:
                if item: self.setScore( item, count_current )
                item = 'love'
                sum_score += count_current
                num_score += 1
                count_current = 0
            elif line.find( '仕事運' ) > 0:
                if item: self.setScore( item, count_current )
                item = 'business'
                sum_score += count_current
                num_score += 1
                count_current = 0
            elif line.find( '金運' ) > 0:
                if item: self.setScore( item, count_current )
                item = 'money'                
                sum_score += count_current
                num_score += 1
                count_current = 0
            else:
                line = line.strip()
                m = re.match( "<FONT color=(.*?)>★</FONT>", line )
                if m and m.group( 1 ) != '#CCCCCC':
                    count_current += 1
                    pass
                m = re.match( "<FONT.*?>(.*?)</FONT>$", line )
                if m:
                    message = m.group( 1 )
                    pass
                pass
            line = fh.readline()
            pass
        if item:
            sum_score += count_current
            num_score += 1
            self.setScore( item, count_current )
            pass
        if message: self.setScore( 'general', int( float( sum_score ) / num_score + .5 ), message )
        fh.close()
        pass
    pass

if __name__ == "__main__":
    obj = newInstance( 'aries' )
    import sys
    obj.parseHTML( sys.argv[ 1 ] )
    print obj
    pass
