#!/usr/bin/python
# -*- coding:utf-8 -*-

from fortunecollector import *
def getInformation():
    return ( 'infoseek', 'constellation', 'Japanese' )

def newInstance( key ):
    return Infoseek_Constellation( key )

class Infoseek_Constellation ( FortuneCollector ):
    def __init__( self, key = None ):
        FortuneCollector.__init__( self, "Infoseek", key )
        if FortuneCollector.CONSTELLATIONS.count( key ) == 0:
            raise Exception( "cannot accept key " + key )
        url = "http://uranai.www.infoseek.co.jp/Uranai?pg=uranai_horo%s.html&sv=RX" % ( key[ 0: 3 ] )
        self.setURL( url )
        self.setScoreUnits( 5 )
        pass
    
    def parseHTML( self, filename ):
        import re, string
        import dom
        fh = open( filename )
        line = fh.readline()
        ## skip
        parser = dom.DOMConverter()
        parser.add_ignoring_tag( 'p' )
        parser.feed( "<html>" )
        while len( line ) > 0:
            if line.find( "alt=\"12星座別 今日の運勢" ) >= 0: break
            line = fh.readline()
            pass
        while len( line ) > 0:
            if line.find( "</table>" ) >= 0: break
            line = fh.readline()
            pass
        count_general  = -1
        count_love     = -1
        count_business = -1
        count_money    = -1
        while len( line ) > 0:
            if line.find( "<SCRIPT" ) >= 0: break
            line = re.sub( "alt=[^\"]([^\\s]+)", "alt=\"\\1\"", line )
            count_general  += line.count( "u_i_sogo.gif" )
            count_love     += line.count( "u_i_love.gif" )
            count_business += line.count( "u_i_work.gif" )
            count_money    += line.count( "u_i_money.gif" )
            #print line
            parser.feed( line )
            line = fh.readline()
            pass
        parser.feed( "</html>" )
        fh.close()
        doc = parser.get_document()
        elem_msg = doc.get_element_at_path( "/html/table/tr/td/table/tr,3/td/table" )
        msg_general = elem_msg.get_element_at_path( "tr,2" ).get_text()
        msg_love    = elem_msg.get_element_at_path( "tr,4" ).get_text()
        msg_business= elem_msg.get_element_at_path( "tr,6" ).get_text()
        msg_money   = elem_msg.get_element_at_path( "tr,8" ).get_text()

        self.setScore( 'general', count_general, msg_general )
        self.setScore( 'love', count_love, msg_love )
        self.setScore( 'money', count_money, msg_money )
        self.setScore( 'business', count_business, msg_business )
        return

    def getEncoding( self ):
        return 'euc-jp'
    
    pass

if __name__ == "__main__":
    obj = newInstance( 'aries' )
    import sys
    obj.parseHTML( sys.argv[ 1 ] )
    print obj
    pass
