#!/usr/bin/python
# -*- coding:utf-8 -*-

from fortunecollector import *

def getInformation():
    return ( 'msn', 'constellation', 'Japanese' )

def newInstance( key ):
    obj =  MSN_Constellation( key )
    return obj

class MSN_Constellation ( FortuneCollector ):
    #MSN_CONSTELLATIONS = [ "aries", "taurus", "gemini", "cancer",
    #                       "leo", "virgo", "libra", "scorpio",
    #                       "sagittarius", "capricorn", "aquarius",
    #                       "pisces"]

    def __init__( self, key = None ):
        FortuneCollector.__init__( self, name = "MSN", key = key )
        if self.CONSTELLATIONS.count( key ) == 0:
            raise Exception( "cannot accept key " + key )
        self.setURL( "http://fortune.msn.co.jp/%s.armx" % ( key ) )
        self.setScoreUnits( 5 )
        pass
    
    def parseHTML( self, filename ):
        import re, string
        fh = open( filename )
        line = fh.readline()
        r_row = re.compile( "<tr>(.*?)</tr>" )
        r_img = re.compile( "/(\\w+)(\\d)\.gif" )
        r_com = re.compile( "<span class=\"comment.*?\">(.*)</span>" )
        while len( line ) > 0:
            #print line
            if line.find( '全体運' ) > 0:
                m = r_row.search( line )
                while m:
                    row = m.group( 1 )
                    next_pos = m.end()
                    #print row
                    m = r_img.search( row )
                    genre = None
                    score = None
                    comment = None
                    if m:
                        genre = m.group( 1 )
                        score = string.atoi( m.group( 2 ) )
                        if genre == 'health': genre = 'business'
                        pass
                    m = r_com.search( row )
                    if m:
                        comment = m.group( 1 )
                        pass
                    if genre and score and comment:
                        self.setScore( genre, score, comment )
                        #print genre, score, comment
                        pass
                    else:
                        break
                    m = r_row.search( line, next_pos )
                    pass
                break
            line = fh.readline()
            pass
        fh.close()
        #print self
        #raise TypeError( "not implemented in this class" )
        pass
    pass

if __name__ == "__main__":
    obj = newInstance( 'aries' )
## .load()
    import sys
    obj.parseHTML( sys.argv[ 1 ] )
    print obj
    pass
