#!/usr/bin/python
# -*- coding:utf-8 -*-

from fortunecollector import *

def getInformation():
    return ( 'yahoo', 'constellation', 'Japanese' )

def newInstance( key ):
    return Yahoo_JP_Constellation( key )

class Yahoo_JP_Constellation ( FortuneCollector ):
    def __init__( self, key = None ):
        FortuneCollector.__init__( self, "MSN", key )
        if FortuneCollector.CONSTELLATIONS.count( key ) == 0:
            raise Exception( "cannot accept key " + key )

        import time
        lt = time.localtime()
        if lt[ 3 ] < 8: lt = time.localtime( time.time() - 24 * 3600 )
        mn = ( "0%d" % ( lt[ 1 ] ) )[ -2: ]
        dt = ( "0%d" % ( lt[ 2 ] ) )[ -2: ]
        url = "http://fortune.yahoo.co.jp/fortune/12astro/%d%s%s/%s.html" % ( lt[ 0 ], mn, dt, key )
        self.setURL( url )
        self.setScoreUnits( 100 )
        pass
    
    def parseHTML( self, filename ):
        import re, string
        import dom
        fh = open( filename )
        line = fh.readline()
        ## skip
        parser = dom.DOMConverter()
        parser.add_ignoring_tag( 'p' )
        parser.feed( "<html>" )
        while len( line ) > 0:
            if line.find( "前日の運勢" ) >= 0: break
            line = fh.readline()
            pass
        while len( line ) > 0:
            if line.find( "この占い結果を友だちに送る" ) >= 0: break
            parser.feed( line )
            line = fh.readline()
            pass
        parser.feed( "</html>" )
        fh.close()
        doc = parser.get_document()
        table = doc.get_element_at_path( "/html/table" )
        while table:
            #print table
            name = table.get_element_at_path( "tr/td,2" ).get_text()
            score = table.get_element_at_path( "tr/td,3" ).get_text()
            message = table.next_sibling().get_text()
            #print score.strip()
            dig = string.atoi( re.search( "\\d+", score.strip() ).group( 0 ) )
            if name == '総合運':
                score = dig
                name = 'general'
            elif name == '恋愛運':
                name = 'love'
                score = dig * 10
            elif name == '金銭運':
                name = 'money'
                score = dig * 10
            elif name == '仕事運':
                name = 'business'
                score = dig * 10
                pass
            else:
                name = None
                pass
            if name:
                self.setScore( name, score, message )
                pass
            try:
                table = table.next_sibling( 'table' )
                table = table.next_sibling( 'table' )
                ##print table
            except:
                break
            pass
        pass

    def getEncoding( self ):
        return 'euc-jp'
    
    pass

if __name__ == "__main__":
    obj = newInstance( 'aries' )
    import sys
    obj.parseHTML( sys.argv[ 1 ] )
    print obj
    pass
